#!/usr/local/bin/perl -- -*-perl-*-

use CGI;
use GIFAlign;
use PfamWWWConfig;

$query = new CGI;

$dbdir = $PfamWWWConfig::data_root;
$ENV{EFETCH_PREFIX}="Pfam(flat):$dbdir/pfam/;tr(flat):$dbdir/trembl/;tr5(flat):$dbdir/trembl5/;sw35(flat):$dbdir/swiss35/;PQ(flat):$dbdir/pfamseq/;";

$aln_type    = $query->param('type');
$acc         = $query->param('acc');
$dom_name    = $query->param('name');
$zoom_factor = $query->param('zoom_factor');
$verbose     = $query->param('verbose');




#inserted to allow user - defined alignments
if ($acc =~ /\buser/)
{
	$ali = new Align;
	$userfile = $PfamWWWConfig::tempdir."/".$acc;
	open(FILE,"$userfile");
	$ali->read_fasta(\*FILE);
	close (FILE);
	system("rm -f $userfile*");
}
if ($acc =~ /\btree/)
{
	$ali = new Align;
	$treefile = $PfamWWWConfig::tempdir."/".$acc;
	$tmpalignfile = $PfamWWWConfig::tempdir."/align_$$";
	open(ALIGNFILE,">$tmpalignfile");
	open(FILE,$treefile);
	while(<FILE>)
	{
		if (/:/)
		{
			@fields = split(/:/,$_);
			unless ($fields[0] =~ /^\d+\.*\d*\b/)
			{
				print ALIGNFILE (">".$fields[0]."\n");
				print ALIGNFILE ("fakedalignment\n");
			}
		}
	}
	close (FILE);
	close (ALIGNFILE);
	open(FILE,$tmpalignfile);
	$ali->read_fasta(\*FILE);
	close (FILE);
	system("rm -f $tmpalignfile");
	system("rm -f $treefile");
}
if ($acc =~ /\bPF/)
{
	$ali = &PfamWWWConfig::get_alignment($acc,$aln_type,1);
}
# up cast to GIFAlign object

bless ($ali,'GIFAlign');

$ali->name($query->param('name'));

print $query->header();

if ($aln_type eq "full") {
  print &PfamWWWConfig::header("All Swissprot+TREMBL proteins with at least one $dom_name domain");
}
elsif ($aln_type eq "seed") {
  print &PfamWWWConfig::header("All Pfam seed members for $dom_name");
}

print "<hr noshade size=2>";
print "Pfam-A domains are large boxes; small three-colored boxes are Pfam-B domains.<br>";
print "Mouseover to see domain descriptions; click on box to enter family page.<br>";
print "(This page uses javascript for the mouseover functionality. Make sure you have javascript enabled in your browser)";
print "<hr noshade size=2>";

$ali->view_all_figures("<a href=\\\"$PfamWWWConfig::swisspfam?name=\$name\\\">\$disname</a>", $zoom_factor, $verbose);
